## pd-ableton-link 0.5~repack

=== external/Makefile ===
# Makefile to build Ableton Link external for Pure Data.
#
# Needs Makefile.pdlibbuilder as helper makefile for platform-dependent build
# settings and rules.
#
# use : make pdincludepath=/path/to/pure-data/src/
#
# The following command will build the external and install the distributable 
# files into a subdirectory called build/abl_link (useful to package later with deken) :
#
# make install pdincludepath=../pure-data/src/ objectsdir=./build

lib.name = abl_link~

abl_link~.class.sources = abl_link~.cpp abl_link_instance.cpp

# all extra files to be included in binary distribution of the library
datafiles = abl_link~-help.pd ../LICENSE

LINK_INCLUDES ?= ./link/include
ASIO_INCLUDES ?= ./link/modules/asio-standalone/asio/include

cflags = -std=c++11 -I$(LINK_INCLUDES) \
	 -I$(ASIO_INCLUDES) -Wno-multichar
    
suppress-wunused = yes

define forLinux
  cflags += -DLINK_PLATFORM_LINUX=1
endef

define forDarwin
  cflags += -DLINK_PLATFORM_MACOSX=1 -mmacosx-version-min=10.9
endef

# TODO: Windows build untested
define forWindows
  cflags += -DLINK_PLATFORM_WINDOWS=1
endef

PDLIBBUILDERDIR ?= .
include $(PDLIBBUILDERDIR)/Makefile.pdlibbuilder

VERSION = $(shell git describe)

update-pdlibbuilder:
	curl https://raw.githubusercontent.com/pure-data/pd-lib-builder/master/Makefile.pdlibbuilder > ./Makefile.pdlibbuilder

deken-source:
	@rm -rf build_src
	@mkdir -p build_src/abl_link~
	@cp $(abl_link~.class.sources) \
		$(patsubst %.cpp, %.hpp, $(abl_link~.class.sources)) \
		$(datafiles) Makefile.pdlibbuilder metronome.pd Makefile \
			build_src/abl_link~
	cd build_src/ ; deken upload -v $(VERSION) abl_link~

deken-binary:
	@rm -rf build
	@make install objectsdir=./build
	cd build/ ; deken upload -v $(VERSION) abl_link~

## pd-ableton-link 0.2

=== debian/changelog ===
pd-ableton-link (0.2-3) unstable; urgency=medium

  * Updated Vcs-* stanzas to salsa.d.o
  * Updated maintainer address
  * Bumped dh-compat to 11
  * Bumped standards version to 4.1.3

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 29 Jan 2018 20:21:57 +0100

pd-ableton-link (0.2-2) unstable; urgency=medium

  * Use system-provided pd-lib-builder Makefile (Closes: #842822)
  * Added d/gbp.conf
  * Added d/source/local-options
  * Canoncial Vcs-Browser stanza

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 23 Nov 2016 23:00:05 +0100

pd-ableton-link (0.2-1) unstable; urgency=medium

  * Initial release (Closes: #842397)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 31 Oct 2016 16:59:26 +0100

=== debian/control ===
Source: pd-ableton-link
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends: debhelper (>= 11~),
 ableton-link-dev,
 pd-lib-builder,
 puredata-dev,
Standards-Version: 4.1.3
Homepage: https://www.ableton.com/en/link/
Vcs-Git: https://salsa.debian.org/multimedia-team/pd/pd-ableton-link.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/pd/pd-ableton-link

Package: pd-ableton-link
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
Description: integration of Ableton Link into Pure Data
 [abl_link~] is a Pd object that integrates Ableton Link into Pure Data (Pd). It
 has four outlets, which emit the index of the current step (at the beginning of
 each step), the current phase and beat time on each DSP tick, as well as the
 tempo on tempo changes. Phase and beat time are Link concepts. The purpose of
 the step feature is to generate events in Pd at a given rate (measured in steps
 per beat).

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:
	make -f debian/build/Makefile \
		CPPFLAGS="$(CPPFLAGS)" \
		CFLAGS="$(CXXFLAGS)" \
		LDFLAGS="$(LDFLAGS)" \
		$(empty)
	dh_auto_build

override_dh_auto_clean:
	make -f debian/build/Makefile clean
	dh_auto_clean

## pd-ableton-link 0.4~repack

=== debian/changelog ===
pd-ableton-link (0.4~repack-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild for mstrict-align

 -- root <root@loongson-pc>  Fri, 28 Jan 2022 17:15:48 +0800

pd-ableton-link (0.4~repack-1) unstable; urgency=medium

  * New upstream version 0.4~repack

  * Use upstream buildsystem
  * Repacked to exclude AblLinkSample/ folder
  * B-D on ableton-link-dev >= 3
    * Set Built-Using stanza (for ableton-link)
  * Added d/watch
  * Updated d/copyright (switching to BSD-3-clause)
    * Added 'licensecheck' target
    * Generated d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 06 Mar 2018 21:02:14 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders: IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Build-Depends: debhelper (>= 11~),
- ableton-link-dev,
+ ableton-link-dev (>= 3~),
  pd-lib-builder,
  puredata-dev,
 Standards-Version: 4.1.3
@@ -14,6 +14,7 @@
 
 Package: pd-ableton-link
 Architecture: any
+Built-Using: ${src:BuiltUsing}
 Depends: ${shlibs:Depends},
  ${misc:Depends},
 Description: integration of Ableton Link into Pure Data

## pd-ableton-link 0.5~repack

=== debian/changelog ===
pd-ableton-link (0.5~repack-1) unstable; urgency=medium

  * New upstream version 0.5~repack

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Added d/README to explain how to load this library
  * Declare that building this package does not require "root" powers
  * Drop obsolete d/source/local-options
  * Bump dh compat to 12
  * Bump standards version to 4.5.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 18 Feb 2020 09:27:43 +0100

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,12 @@
 Priority: optional
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders: IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 12),
  ableton-link-dev (>= 3~),
  pd-lib-builder,
  puredata-dev,
-Standards-Version: 4.1.3
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://www.ableton.com/en/link/
 Vcs-Git: https://salsa.debian.org/multimedia-team/pd/pd-ableton-link.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/pd/pd-ableton-link

=== debian/watch ===
# process this file with uscan(1)
version=3
opts=\
repack,repacksuffix=~repack,\
dversionmangle=s/[~+](dfsg|repack)(\.\d*)?$//,\
filenamemangle=s%.*/v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@_$1$2%\
  https://github.com/libpd/abl_link/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@

## pd-ableton-link 0.6~ds0

=== android/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

set(PD_CORE ${CMAKE_CURRENT_LIST_DIR}/../../pd-for-android/PdCore)

add_library(pd SHARED IMPORTED)
set_target_properties(pd PROPERTIES IMPORTED_LOCATION
  ${PD_CORE}/libs/${ANDROID_ABI}/libpd.so)

include_directories(${PD_CORE}/jni/libpd/pure-data/src)
include_directories(../external/android-ifaddrs)
include_directories(../external/link/include)
include_directories(../external/link/modules/asio-standalone/asio/include)

add_library(abl_link_tilde SHARED
  ../external/android-ifaddrs/ifaddrs.cpp ../external/abl_link_instance.cpp
  ../external/abl_link~.cpp)
target_compile_definitions(abl_link_tilde PRIVATE
  ANDROID=1 LINK_PLATFORM_LINUX=1 PD=1 ABL_LINK_OFFSET_MS=23)
set(CMAKE_CXX_FLAGS "-std=c++11 -Wno-multichar -fexceptions -Werror")
            
target_link_libraries(abl_link_tilde pd)

=== external/Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 abl_link~.class.sources = abl_link~.cpp abl_link_instance.cpp
 
 # all extra files to be included in binary distribution of the library
-datafiles = abl_link~-help.pd ../LICENSE
+datafiles = abl_link~-help.pd ../LICENSE metronome.pd
 
 LINK_INCLUDES ?= ./link/include
 ASIO_INCLUDES ?= ./link/modules/asio-standalone/asio/include
@@ -33,9 +33,10 @@
   cflags += -DLINK_PLATFORM_MACOSX=1 -mmacosx-version-min=10.9
 endef
 
-# TODO: Windows build untested
+
 define forWindows
   cflags += -DLINK_PLATFORM_WINDOWS=1
+  ldlibs += -lws2_32 -liphlpapi -static -lpthread
 endef
 
 PDLIBBUILDERDIR ?= .

=== debian/changelog ===
pd-ableton-link (0.6~ds0-6) unstable; urgency=medium

  * Explicitly set buildsystem to 'pd_lib_builder' (Closes: #1032124)
  * Bump standards version to 4.6.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 02 Mar 2023 23:19:13 +0100

pd-ableton-link (0.6~ds0-5) unstable; urgency=medium

  * Modernize 'licensecheck' target
    + Ensure that 'licensecheck' is run with the C.UTF-8 locale
    + Exclude debian/ from 'licensecheck'
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 07 Dec 2022 10:35:09 +0100

pd-ableton-link (0.6~ds0-4) unstable; urgency=medium

  * Switch to dh-sequence-pd-lib-builder
    + Add patch to use standard pd-lib-builder make-vars
  * Modernize 'licensecheck' target
    + Re-generated d/copyright_hints
  * Bump standards version to 4.6.1

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 24 Nov 2022 22:49:55 +0100

pd-ableton-link (0.6~ds0-3) unstable; urgency=medium

  * Fix d/watch

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 16 Aug 2022 13:48:36 +0200

pd-ableton-link (0.6~ds0-2) unstable; urgency=medium

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Add patch to allow compilation with Pd>=0.52
  * Fix upstream repository
  * Apply "warp-and-sort -ast"

  [ Debian Janitor ]
  * Set upstream metadata fields:
    Bug-Database, Bug-Submit, Repository, Repository-Browse.
  * Remove constraints unnecessary since buster

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 20 Dec 2021 09:41:28 +0100

pd-ableton-link (0.6~ds0-1) unstable; urgency=medium

  * New upstream version 0.6~ds0
  * Update versionmangling and repacksuffix rules in d/watch
  * Add salsa-ci configuration
  * Bump dh-compat to 13
  * Bump standards version to 4.6.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 24 Aug 2021 16:46:57 +0200

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,13 @@
 Section: sound
 Priority: optional
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
-Uploaders: IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
-Build-Depends: debhelper-compat (= 12),
- ableton-link-dev (>= 3~),
- pd-lib-builder,
- puredata-dev,
-Standards-Version: 4.5.0
+Uploaders:
+ IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
+Build-Depends:
+ ableton-link-dev,
+ debhelper-compat (= 13),
+ dh-sequence-pd-lib-builder,
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://www.ableton.com/en/link/
 Vcs-Git: https://salsa.debian.org/multimedia-team/pd/pd-ableton-link.git
@@ -15,9 +16,11 @@
 
 Package: pd-ableton-link
 Architecture: any
-Built-Using: ${src:BuiltUsing}
-Depends: ${shlibs:Depends},
+Built-Using:
+ ${src:BuiltUsing},
+Depends:
  ${misc:Depends},
+ ${shlibs:Depends},
 Description: integration of Ableton Link into Pure Data
  [abl_link~] is a Pd object that integrates Ableton Link into Pure Data (Pd). It
  has four outlets, which emit the index of the current step (at the beginning of

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Dexternal --buildsystem=pd_lib_builder

override_dh_auto_install:

ABLETONLINK_VERSION := $(shell dpkg-query --show --showformat='$${source:Version}' ableton-link-dev)
override_dh_gencontrol:
	dh_gencontrol -- \
                -Vsrc:BuiltUsing="ableton-link ( = $(ABLETONLINK_VERSION) )"

DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
	debian/.*
# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

=== debian/watch ===
# process this file with uscan(1)
version=4
opts=\
repack,repacksuffix=~ds0,\
dversionmangle=s/@DEB_EXT@//,\
filenamemangle=s%.*/v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@_$1$2% \
  https://github.com/libpd/abl_link/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@
